VERSION 5.00
Begin VB.UserControl PropertyList 
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3180
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   KeyPreview      =   -1  'True
   ScaleHeight     =   212
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "PropertyList.ctx":0000
End
Attribute VB_Name = "PropertyList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'' Property Editor Active-X Control
''
'' Version 1.0
''
''
'' PropertyList.ctl - UserControl Module

'' Copyright (C) 2000 The Southern Cross.
'' All Rights Reserved.

'' Unauthorized Commercial Use Strictly Prohibited.

Private m_Ctrl As Boolean

''
Private WithEvents m_List As ListWnd
Attribute m_List.VB_VarHelpID = -1
Private WithEvents m_Multi As EditWnd
Attribute m_Multi.VB_VarHelpID = -1

Private Const MULTILINE_HEIGHT = 8
Private Const cm_ButtonWidth = 16

Private m_Col As Collection

Option Explicit

Private m_DisableNoScroll As Boolean

Private m_AutoEdit As Boolean
Private m_DoingEdit As Boolean
Private EditIndex As Long
Private rn_Sel As String

Private m_Init As Boolean

Public Enum ListboxStyleConstants
    clsWantKeyboardInput = &H400&
End Enum

Public Enum ListboxScrollBars
    lbsNone = 0
    lbsHorizontal = 1
    lbsVertical = 2
    lbsBoth = 3
End Enum

Private m_NameMargin As Long

Private m_hWnd As Long

'' Coordinates stored in pixels

Private m_Create As CREATESTRUCT

Private m_ColumnWidth As Long
Private m_Style As ListboxStyleConstants

Private WithEvents m_Font As StdFont
Attribute m_Font.VB_VarHelpID = -1

Private m_Scroll As ListboxScrollBars

Private m_hFont_Canvas As Long

Private m_MaxTextLines As Long

Public Event Click()
Public Event DblClick()
Public Event SelChange(Index As Long)
Public Event Ellipses(Index As Long)

Public Event PropertyChange(Item As PropertyType)
Public Event KeyUp(KeyCode As Long, Shift As Integer)
Public Event KeyDown(KeyCode As Long, Shift As Integer)

Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

Public Function AddItem(ByVal PropertyName As String, ByVal PropertyType As PropertyTypeConstants, Optional ByVal InsertBefore As Long = -1) As PropertyType

    Dim newObject As New PropertyType, _
        x As Long
    
    Dim var As PropertyType
    
    Set newObject.Owner = Me
    newObject.Edit.Create m_hWnd, "", 0, 0
    
    newObject.Name = PropertyName
    newObject.PropertyType = PropertyType
        
    If (newObject.PropertyType = ptcNumeric) Then
        newObject.Edit.Text = "0"
    End If
    
    If (InsertBefore >= 0) Then
        m_Col.Add newObject, , (InsertBefore + 1)
    Else
        m_Col.Add newObject
    End If
    
    x = SendMessage(m_hWnd, LB_INSERTSTRING, InsertBefore, ByVal StrPtr(newObject.Name))
    
    Set AddItem = newObject
    Set newObject = Nothing
        
    x = 0
    For Each var In m_Col
        var.Index = x
        x = x + 1
    Next var
        
    ComputeNameMargin
        
End Function

Public Property Get List(ByVal Index As Long) As PropertyType
        
    If (Index <> -1&) Then
        On Error Resume Next
        
        Set List = m_Col(CLng(Index + 1))
    End If
    
End Property

Public Property Get ListIndex() As Long

    ListIndex = SendMessage(m_hWnd, LB_GETCURSEL, 0&, ByVal 0&)
    
End Property

Public Property Let ListIndex(ByVal Index As Long)
    
    If (m_List.Visible = True) Then
        m_List_Click
    End If
    
    If (m_Multi.Visible = True) Then
        m_Ctrl = False
        m_Multi_KeyUp 13, 0
    End If
    
    SendMessage m_hWnd, LB_SETCURSEL, Index, ByVal 0&
    
End Property

Public Property Get ListCount() As Long
    
    ListCount = SendMessage(m_hWnd, LB_GETCOUNT, 0&, ByVal 0&)
    
End Property

Public Property Get SelItem() As PropertyType
    
    If (ListIndex <> -1&) Then
        Set SelItem = List(ListIndex)
    Else
        Set SelItem = Nothing
    End If

End Property

Public Sub Clear()
    SendMessage m_hWnd, LB_RESETCONTENT, 0&, ByVal 0&
    Set m_Col = Nothing
    Set m_Col = New Collection
End Sub

Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = m_Col.[_NewEnum]
End Function


Public Property Get MaxTextLines() As Long
    MaxTextLines = m_MaxTextLines
End Property

Public Property Let MaxTextLines(ByVal vData As Long)
    If (m_Multi.Visible = True) Then
        m_Multi_KeyUp 13, 0
    End If
    
    m_MaxTextLines = vData
    PropertyChanged "MaxTextLines"
    
End Property

Public Property Get AutoEdit() As Boolean
    AutoEdit = m_AutoEdit
End Property

Public Property Let AutoEdit(ByVal vData As Boolean)
    m_AutoEdit = vData
    PropertyChanged "AutoEdit"
End Property

Public Property Get Text() As String
    Dim tx(0 To 256) As Byte
    
    SendMessage m_hWnd, WM_GETTEXT, 256, tx(0)
    Text = CStrToString(tx)
End Property

Public Property Let Text(ByVal vData As String)
    Dim tx(0 To 256) As Byte
    
    StringToCStr vData, tx
    SendMessage m_hWnd, WM_SETTEXT, 0&, tx(0)
End Property

Public Property Get Font() As StdFont
    Set Font = m_Font
End Property

Public Property Set Font(sFont As StdFont)
    Set m_Font = sFont
    SetFont
    PropertyChanged "Font"
End Property

Public Property Get WantKeyboardInput() As Boolean
    WantKeyboardInput = CBool(m_Style And clsWantKeyboardInput)
End Property

Public Property Let WantKeyboardInput(ByVal vData As Boolean)
    If Ambient.UserMode Then Exit Property
    
    If (vData = False) Then
        m_Style = m_Style And (-1& Xor clsWantKeyboardInput)
    Else
        m_Style = m_Style Or clsWantKeyboardInput
    End If
    
    ReCreate
    PropertyChanged "Style"
    
End Property

Public Property Get ScrollBars() As ListboxScrollBars
    ScrollBars = m_Scroll
End Property

Public Property Let ScrollBars(ByVal varScrollBars As ListboxScrollBars)
    If Ambient.UserMode Then Exit Property
    
    If m_Scroll <> varScrollBars Then
    
        m_Scroll = varScrollBars
        ReCreate
        
        PropertyChanged "ScrollBars"
    End If
    
End Property

Public Property Get ColumnWidth() As Long
    ColumnWidth = m_ColumnWidth
End Property

Public Property Let ColumnWidth(ByVal vData As Long)
    If m_ColumnWidth <> vData Then
    
        m_ColumnWidth = vData
        SendMessage m_hWnd, LB_SETCOLUMNWIDTH, vData, ByVal 0&
        PropertyChanged "ColumnWidth"
    End If
    
End Property

Public Property Get DisableNoScroll() As Boolean
    DisableNoScroll = m_DisableNoScroll
End Property

Public Property Let DisableNoScroll(ByVal vData As Boolean)
    m_DisableNoScroll = vData
    PropertyChanged "DisableNoScroll"
    ReCreate
    
End Property

Public Property Get NameMargin() As Long
    NameMargin = m_NameMargin
End Property

Friend Property Get Extender() As VBControlExtender
    Set Extender = UserControl.Extender
End Property

Friend Property Get hFont() As Long
    hFont = m_hFont_Canvas
End Property

Friend Sub DrawButton(ByVal ItemIndex As Long, ByVal Pushed As Boolean, Optional ByVal CompareState As Boolean = False, Optional ByVal ThisDC As Long = 0&, Optional ByVal DrawFF As Boolean)
    Static LState As Boolean
    
    Dim lpRect As RECT, _
        pDC As Long, _
        pType As PropertyTypeConstants
            
    Dim lpSize As SIZE
            
    If ItemIndex = -1& Then Exit Sub
    pType = List(ItemIndex).PropertyType
    
    If CompareState = True Then
        If Pushed = LState Then Exit Sub
    End If
    
    If (DrawFF = False) Then
    
        pDC = GetDC(m_hWnd)
        GetButtonRect lpRect, SelItem
    Else
        pDC = ThisDC
        SelItem.GetRect lpRect
        lpRect.Right = lpRect.Right - lpRect.Left
        lpRect.Left = lpRect.Right - ButtonWidth
        
        lpRect.Bottom = lpRect.Bottom - lpRect.Top
        lpRect.Top = 1
        
    End If
        
    Select Case pType
    
        Case ptcEnum, ptcBoolean, ptcObject, ptcMultiline
        
            DrawFrameControl pDC, lpRect, DFC_SCROLL, DFCS_ADJUSTRECT + DFCS_SCROLLDOWN + (DFCS_PUSHED And Pushed)

        Case ptcEllipses, ptcEditEllipses
        
            DrawFrameControl pDC, lpRect, DFC_BUTTON, DFCS_ADJUSTRECT + DFCS_BUTTONPUSH + (DFCS_PUSHED And Pushed)
            
            SelectObject pDC, m_hFont_Canvas
            SetBkMode pDC, TRANSPARENT
            SetTextColor pDC, GetSysColor(COLOR_WINDOWTEXT)
                                                
            GetTextExtentPoint32 pDC, "...", 3, lpSize
            TextOut pDC, lpRect.Left + 1, (lpRect.Top - 2), "...", 3
            
    End Select
    
    If DrawFF = False Then
        ReleaseDC pDC, m_hWnd
    End If

    LState = Pushed

End Sub


Private Sub ComputeNameMargin()
    Dim P As PropertyType, _
        m As Long, _
        lpSize As SIZE, _
        mDC As Long
    
    Dim l As Long, _
        i As Long
    
    SendMessage m_hWnd, WM_SETFONT, hFont, ByVal 0&
    mDC = GetWindowDC(m_hWnd)
    SelectObject mDC, hFont
    
    If mDC = 0& Then Exit Sub
    
    l = ListCount - 1
    
    For i = 0 To l
        
        GetTextExtentPoint32 mDC, CStr(List(i).Name + Chr(0)), Len(List(i).Name), lpSize
        If (lpSize.cx > m) Then
            m = lpSize.cx
        End If
    
    Next i
        
    m_NameMargin = m + 8
    
    ReleaseDC m_hWnd, mDC
    
End Sub

Friend Property Get ButtonWidth() As Long
    
    ButtonWidth = cm_ButtonWidth
    
End Property

Private Sub GetButtonRect(lpRect As RECT, ByVal varItem As PropertyType)
        
    varItem.GetRect lpRect
    lpRect.Left = lpRect.Right - ButtonWidth
    lpRect.Top = lpRect.Top + 1

End Sub

Private Sub WhenButton(ByVal varItem As PropertyType)
    Dim v, c As Long
    Dim lpRect As RECT
                        
    Select Case varItem.PropertyType
        
        Case ptcEllipses, ptcEditEllipses
            
            RaiseEvent Ellipses(ListIndex)
            ' RaiseEvent PropertyChange(SelItem)
            
        Case ptcMultiline
        
            If (m_List.Visible = True) Then
                m_List_Click
            End If
        
            If (m_Multi.Visible = True) Then
                m_Multi_KeyUp 13, 0
                Exit Sub
            End If
        
            SelItem.GetRect lpRect
            m_Multi.Move lpRect.Left + NameMargin, lpRect.Bottom, ((lpRect.Right - lpRect.Left) + 1) - NameMargin, ((lpRect.Bottom - lpRect.Top) + 1) * m_MaxTextLines
            m_Multi.Text = SelItem.Value
            
            m_Multi.Visible = True
            m_Multi.SetFocus
                
        Case ptcBoolean, ptcEnum
        
            If (m_List.Visible = True) Then
                m_List_Click
                Exit Sub
            End If
            
            If (m_Multi.Visible = True) Then
                m_Ctrl = False
                m_Multi_KeyUp 13, 0
            End If
                    
            SelItem.GetRect lpRect
            
            m_List.Clear
            
            If varItem.PropertyType = ptcBoolean Then
                m_List.AddItem "False"
                m_List.AddItem "True"
            
                m_List.ListIndex = (1 And SelItem.Value)
                m_List.Move lpRect.Left + NameMargin, lpRect.Bottom, ((lpRect.Right - lpRect.Left) + 1) - NameMargin, ((lpRect.Bottom - lpRect.Top)) * 2
            Else
                
                For Each v In varItem.Enums.Strings
                    m_List.AddItem CStr(v)
                    If (CStr(v) = varItem.Value) Then
                        m_List.ListIndex = c
                    End If
                    c = c + 1
                Next v
                
                m_List.Move lpRect.Left + NameMargin, lpRect.Bottom, ((lpRect.Right - lpRect.Left) + 1) - NameMargin, ((lpRect.Bottom - lpRect.Top)) * varItem.Enums.Count
                If (m_List.Height > 150) Then m_List.Height = 150
            End If
            
            Dim x As PropertyType
            
            For Each x In m_Col
                If (x.PropertyType = ptcEditEllipses) Or _
                    (x.PropertyType = ptcNumeric) Or (x.PropertyType = ptcString) Then
                    SendMessage x.Edit.hWnd, WM_SETREDRAW, False, ByVal 0&
                
                End If
            Next x
        
            m_List.Visible = True
            m_List.SetFocus
    
    End Select
    
End Sub

Private Sub SetFont(Optional ByVal Redraw As Boolean = True)
    Dim vhFont As Long, _
        lfData As LOGFONT, _
        lpSize As SIZE
    
    Static Setting As Boolean
    
    If Setting = True Then Exit Sub
    Setting = True
    
    GetLogFont m_Font, lfData, hDC
        
    ' lfData.lfHeight = Abs(MulDiv(m_Font.SIZE, GetDeviceCaps(hDC, LOGPIXELSY), 72))
    
    vhFont = CreateFontIndirect(lfData)
        
    SendMessage m_hWnd, WM_SETFONT, vhFont, ByVal Redraw
    SendMessage hWnd, WM_SETFONT, vhFont, ByVal True
    
    If m_hFont_Canvas <> 0 Then
        DeleteObject m_hFont_Canvas
    End If
        
    m_hFont_Canvas = vhFont
    SelectObject hDC, vhFont
        
    Setting = False
    UserControl_Resize
    
    Set m_List.Font = m_Font
    Set m_Multi.Font = m_Font
        
End Sub

Private Sub CreateListBox()
    Dim proc As Long
    
    With m_Create
    
        .Style = (WS_CHILD Or _
                 WS_VISIBLE Or _
                 LBS_OWNERDRAWVARIABLE Or _
                 LBS_NOTIFY Or _
                 LBS_NODATA Or _
                 LBS_NOINTEGRALHEIGHT Or _
                 (LBS_DISABLENOSCROLL And m_DisableNoScroll) Or _
                 m_Style)
        
        If (m_Scroll And lbsHorizontal) Then .Style = (.Style Or WS_HSCROLL)
        If (m_Scroll And lbsVertical) Then .Style = (.Style Or WS_VSCROLL)
                
        .x = 0
        .Y = 0
        .cx = ScaleWidth
        .cy = ScaleHeight
        .lpszClass = "LISTBOX"
        .lpszName = ""
        .hInstance = App.hInstance
        .hWndParent = hWnd
        .lpCreateParams = VarPtr(m_Create)
        .ExStyle = 0
        .hMenu = 0
        
        m_hWnd = CreateWindowEx(.ExStyle, .lpszClass, .lpszName, .Style, .x, .Y, .cx, .cy, .hWndParent, .hMenu, .hInstance, m_Create)
        AddControl m_hWnd, Me
        
        If (Ambient.UserMode = True) And (GetOldProc(m_hWnd) = 0) Then
                    
            proc = SetWindowLong(m_hWnd, GWL_WNDPROC, AddressOf ListHandleProc)
            AddHandle m_hWnd, proc
            
            SetFont
        End If
            
        SendMessage m_hWnd, LB_SETCOLUMNWIDTH, m_ColumnWidth, ByVal 0&
        
        m_List.Create m_hWnd, "", 0, 0
        m_Multi.Create m_hWnd, "", 0, 0
        
    End With

End Sub


Private Sub DestroyListBox()

    If m_hWnd <> 0 Then
    
        m_List.Destroy
        m_Multi.Destroy
        
        RemoveControl m_hWnd
        
        SetWindowLong m_hWnd, GWL_WNDPROC, GetOldProc(m_hWnd)
        RemoveHandle m_hWnd
        DestroyWindow m_hWnd
        
    End If

End Sub

Private Sub ReCreate()

    Clear
    DestroyListBox

    m_Init = False
    UserControl_Resize
    
End Sub

Private Sub m_List_Click()
    Dim v As Variant, c As Long
    Dim x As PropertyType
    
    Select Case SelItem.PropertyType
    
        Case ptcBoolean
        
            SelItem.Value = CBool(m_List.ListIndex)
            
        Case ptcEnum
            
            For Each v In SelItem.Enums.Strings
                If (CStr(v) = m_List.List(m_List.ListIndex)) Then
                    SelItem.Value = v
                    Exit For
                End If
                c = c + 1
            Next v
                                        
    End Select
    
    For Each x In m_Col
        
        If (x.PropertyType = ptcEditEllipses) Or _
            (x.PropertyType = ptcNumeric) Or (x.PropertyType = ptcString) Then
            SendMessage x.Edit.hWnd, WM_SETREDRAW, True, ByVal 0&
        
            x.Edit.Visible = False
            x.Edit.Visible = True
        End If
    Next x

    RaiseEvent PropertyChange(SelItem)
    
    m_List.Visible = False
    ListIndex = ListIndex
    
End Sub

Private Sub m_List_KeyDown(KeyCode As Long, Shift As Long)
    Dim v As Variant, c As Long
    Dim x As PropertyType
    
    If (KeyCode = 27) Then
        
        m_List.Visible = False
        m_List.Clear
        
        For Each x In m_Col
            
            If (x.PropertyType = ptcNumeric) Or (x.PropertyType = ptcString) _
                Or (x.PropertyType = ptcEditEllipses) Then
                SendMessage x.Edit.hWnd, WM_SETREDRAW, True, ByVal 0&
            
                x.Edit.Visible = False
                x.Edit.Visible = True
            End If
        Next x

    End If
    
End Sub

Private Sub m_List_Paint()

    Dim lpRect As RECT, _
        hDC As Long, _
        hPen As Long, _
        lpPoint As POINTAPI
    
    lpRect.Bottom = m_List.Height - 1
    lpRect.Right = m_List.Width - 1
    
    hDC = GetWindowDC(m_List.hWnd)
    hPen = CreatePen(PS_SOLID, 1, GetActualColor(&H80000000 Or COLOR_WINDOWTEXT))

    SelectObject hDC, hPen
    
    With lpRect
    
        MoveToEx hDC, .Left, .Top, lpPoint
        LineTo hDC, .Left, .Bottom
        LineTo hDC, .Right, .Bottom
        LineTo hDC, .Right, .Top
        LineTo hDC, .Left, .Top
    End With
    
    DeleteObject hPen
    ReleaseDC m_List.hWnd, hDC
    
End Sub


Private Sub m_Multi_KeyDown(KeyCode As Long, Shift As Long)

    If KeyCode = vbKeyControl Then m_Ctrl = True
    
End Sub

Private Sub m_Multi_KeyUp(KeyCode As Long, Shift As Long)
    
    If (KeyCode = 13) Then
        If m_Ctrl = False Then
            Dim s As String
            s = m_Multi.Text
            
            If (Len(s)) Then
                If (Mid(s, Len(s) - 1, 2) = vbCrLf) Then
                    SelItem.Value = Mid(s, 1, Len(s) - 2)
                Else
                    SelItem.Value = m_Multi.Text
                End If
            Else
                SelItem.Value = ""
            End If
            
            m_Multi.Visible = False
            m_Multi.Text = ""
        
            ListIndex = ListIndex
            RaiseEvent PropertyChange(SelItem)
            
'            m_GDI_h.SetFocus m_hWnd
        End If
        
    ElseIf KeyCode = 27 Then
                
        m_Multi.Visible = False
        m_Multi.Text = ""
        
        ListIndex = ListIndex
        m_GDI_h.SetFocus m_hWnd
    
    End If
    
    If (KeyCode = vbKeyControl) Then
        m_Ctrl = False
    End If
    
End Sub

Private Sub UserControl_Initialize()
    On Error Resume Next
    
    Set m_Col = New Collection
    InitCols
    
    ScaleMode = 3
    
    m_AutoEdit = True
    
    m_NameMargin = 40
    m_Scroll = lbsBoth
    m_ColumnWidth = 300
    m_Style = clsWantKeyboardInput
    EditIndex = -1&
    
    AddControl hWnd, Me
    
    Set m_List = New ListWnd
    Set m_Multi = New EditWnd
    
    m_List.Visible = False
    m_List.ThreedBorder = False
    m_List.Style = lsStandard
    
    m_Multi.Visible = False
    m_Multi.ThreedBorder = False
    m_Multi.Style = esAutoHScroll + esAutoVScroll + esLeft + _
                  esMultiline + esvScroll + esBorder
        
    m_MaxTextLines = 5
    
End Sub

Private Sub UserControl_Terminate()
        
    SendMessage m_hWnd, LB_RESETCONTENT, 0&, ByVal 0&
    DestroyListBox
    
    Set m_Col = Nothing
    
    SetWindowLong hWnd, GWL_WNDPROC, GetOldProc(hWnd)
    RemoveHandle hWnd
    RemoveControl hWnd
    
End Sub


Private Sub UserControl_EnterFocus()
    
    If m_hWnd <> 0 Then
        m_GDI_h.SetFocus m_hWnd
    End If
    
End Sub

Private Sub UserControl_GotFocus()
    m_GDI_h.SetFocus m_hWnd
End Sub

Private Sub UserControl_Resize()
    Static Sizing As Boolean
    
    Dim s As SIZE
    Dim rcItem As RECT, _
        proc As Long, _
        IsDrop As Boolean
    
    Dim leWidth As Long, _
        pItem As PropertyType, _
        lpRect As RECT
    
    If Sizing = True Then Exit Sub
    
    ScaleMode = 3
    Sizing = True
    
    If (m_Init = False) And Not (m_Font Is Nothing) Then
        
        CreateListBox
        m_Init = True
    
        If (Ambient.UserMode = True) And (GetOldProc(hWnd) = 0) Then
                    
            proc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf ListWndProc)
            AddHandle hWnd, proc
        
        End If
            
    End If
    
    SendMessage m_hWnd, LB_SETCOLUMNWIDTH, m_ColumnWidth, ByVal 0
    MoveWindow m_hWnd, 0, 0, ScaleWidth, ScaleHeight, True
    
    For Each pItem In m_Col
    
        If (pItem.Edit.Visible = True) Then
            pItem.Edit.Visible = False
        End If
    
    Next pItem
    SendMessage m_hWnd, WM_PAINT, 0, ByVal 0
            
    Sizing = False
    
End Sub


Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    
    '' m_ = PropBag.ReadProperty ("")
    
    Set m_Font = New StdFont
    
    m_Style = PropBag.ReadProperty("Style", m_Style)
    m_Scroll = PropBag.ReadProperty("ScrollBars", m_Scroll)
    m_ColumnWidth = PropBag.ReadProperty("ColumnWidth", m_ColumnWidth)
    m_NameMargin = PropBag.ReadProperty("NameMargin", m_NameMargin)
    m_AutoEdit = PropBag.ReadProperty("AutoEdit", m_AutoEdit)
    m_DisableNoScroll = PropBag.ReadProperty("DisableNoScroll", m_DisableNoScroll)
    m_MaxTextLines = PropBag.ReadProperty("MaxTextLines", m_MaxTextLines)
    Set m_Font = PropBag.ReadProperty("Font", m_Font)
    
    ReCreate
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    
    '' PropBag.WriteProperty "", m_

    PropBag.WriteProperty "Style", m_Style
    PropBag.WriteProperty "Font", m_Font
    PropBag.WriteProperty "ScrollBars", m_Scroll
    PropBag.WriteProperty "ColumnWidth", m_ColumnWidth
    PropBag.WriteProperty "NameMargin", m_NameMargin
    PropBag.WriteProperty "AutoEdit", m_AutoEdit
    PropBag.WriteProperty "DisableNoScroll", m_DisableNoScroll
    PropBag.WriteProperty "MaxTextLines", m_MaxTextLines
    
End Sub

Friend Sub SelEvent(ByVal pType As PropertyType)
    RaiseEvent PropertyChange(pType)
End Sub

Private Sub m_Font_FontChanged(ByVal PropertyName As String)

    SetFont

End Sub

Friend Sub FireEvent(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)

    Dim v As Variant, x As Long
                        
    Dim lpPoint As POINTAPI
    Dim lpRect As RECT
    
    Dim LastSel As PropertyType
    
    Static WasButton As Boolean

    Select Case uMsg:
        
        Case WM_KEYUP
        
            If (wParam = 9) Then
                Select Case SelItem.PropertyType
                
                    Case ptcBoolean, ptcEnum, ptcMultiline, ptcEllipses
                    
                        If (m_Multi.Visible = True) Then
                            m_Ctrl = False
                            m_Multi_KeyUp 13, 0
                        End If
                        
                        If (m_List.Visible = True) Then
                            m_List_Click
                        End If
                        
                        WhenButton (SelItem)
                        
                    Case ptcString, ptcNumeric, ptcEditEllipses
                    
                        SelItem.Edit.SetFocus
                        
                End Select
                
            ElseIf (wParam = vbKeyDelete) Then
                
                SelItem.Value = Empty
                ListIndex = ListIndex
                
            End If
        
        Case WM_VSCROLL, WM_HSCROLL
            
            If (m_List.Visible = True) Then
                m_List_Click
            End If
            
            If (m_Multi.Visible = True) Then
                m_Ctrl = False
                m_Multi_KeyUp 13, 0
            End If
        
        Case WM_LBUTTONDOWN
                   
            If (m_Multi.Visible = True) Then
                m_Ctrl = False
                m_Multi_KeyUp 13, 0
            End If
                                
            PointFromLong lParam, lpPoint
            GetButtonRect lpRect, SelItem
            
            If (WithinRect(lpRect, lpPoint.x, lpPoint.Y)) Then
                SetCapture (m_hWnd)
                DrawButton ListIndex, True
                WasButton = True
            End If
                
        Case WM_LBUTTONUP
        
            If (WasButton) Then
                ReleaseCapture
                DrawButton ListIndex, False
                WasButton = False
                
                WhenButton SelItem
            Else
                ListIndex = ListIndex
            End If
    
            
        Case WM_MOUSEWHEEL:
            
            Dim n As Integer
            n = CInt(((wParam And &HFFFF) / &H10000))
            
            Set LastSel = SelItem
            If LastSel.PropertyType = ptcBoolean Then
                LastSel.Value = (-1& Xor LastSel.Value)
                
                ListIndex = ListIndex
                
            ElseIf (LastSel.PropertyType = ptcEnum) Then
                
                For Each v In LastSel.Enums.Strings
                    If LastSel.Value = v Then
                        
                        If (n = 120) Then
                            If x < (LastSel.Enums.Count - 1) Then
                                LastSel.Value = LastSel.Enums.Item(x + 1)
                            Else
                                LastSel.Value = LastSel.Enums.Item(0)
                            End If
                        ElseIf n = -120 Then
                            If x > 0 Then
                                LastSel.Value = LastSel.Enums.Item(x - 1)
                            Else
                                LastSel.Value = LastSel.Enums.Item(LastSel.Enums.Count - 1)
                            End If
                        End If
                    
                        Exit For
                    
                    End If
                    x = x + 1
                Next v
                
                If (x = LastSel.Enums.Count) Then
                    LastSel.Value = LastSel.Enums.Item(0)
                End If
                
                ListIndex = ListIndex
            End If
                            
        Case WM_COMMAND:
        
            Select Case ((wParam And &HFFFF0000) / &H10000)
            
                Case LBN_SELCHANGE
                
                    If (m_List.Visible = True) Then
                        m_List_Click
                    End If
                    
                    If (m_Multi.Visible = True) Then
                        m_Multi_KeyUp 13, 0
                    End If
                    
                    Set LastSel = SelItem
                
                Case LBN_DBLCLK
                
                    If (SelItem.PropertyType = ptcBoolean) Then
                        SelItem.Value = (-1& Xor SelItem.Value)
                        
                        ListIndex = ListIndex
                        RaiseEvent PropertyChange(SelItem)
                    ElseIf (SelItem.PropertyType = ptcEnum) Then
                        
                        For Each v In SelItem.Enums.Strings
                            If SelItem.Value = v Then
                                If x < (SelItem.Enums.Count - 1) Then
                                    SelItem.Value = SelItem.Enums.Item(x + 1)
                                Else
                                    SelItem.Value = SelItem.Enums.Item(0)
                                End If
                            
                                Exit For
                            
                            End If
                            x = x + 1
                        Next v
                        
                        If (x = SelItem.Enums.Count) Then
                            SelItem.Value = SelItem.Enums.Item(0)
                        End If
                        
                        ListIndex = ListIndex
                        RaiseEvent PropertyChange(SelItem)
                    
                    ElseIf (SelItem.PropertyType = ptcMultiline) Then
                            
                        WhenButton SelItem
                    
                    ElseIf (SelItem.PropertyType = ptcEllipses) Or _
                        (SelItem.PropertyType = ptcEditEllipses) Then
                        
                        RaiseEvent Ellipses(SelItem.Index)
                    
                    End If
                
            End Select
            
    End Select

End Sub

