VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PropertyType"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'' Property Editor Active-X Control
''
'' Version 1.0
''
''
'' PropertyType.cls - PropertyType Class Module

'' Copyright (C) 2000 The Southern Cross.
'' All Rights Reserved.

'' Unauthorized Commercial Use Strictly Prohibited.
''

Option Explicit

Private WithEvents m_Edit As EditWnd
Attribute m_Edit.VB_VarHelpID = -1

Private m_Rect As RECT

Public Changed As Boolean
Public Name As String

Private m_Index As Long

Public Enum PropertyTypeConstants
    ptcString = 0
    ptcEnum = 1
    ptcEllipses = 2
    ptcNumeric = 4
    ptcBoolean = 8
    ptcObject = 16
    
    ptcMultiline = 32
    
    ptcEditEllipses = 64
    
End Enum

Private m_Value As Variant
Private m_PropertyType As PropertyTypeConstants
Private m_ObjectClass As String
Private m_Enums As EnumsType

Private m_Object As Object
Private m_Owner As PropertyList

Public Property Get Index() As Long
    Index = m_Index
End Property

Friend Property Let Index(ByVal vData As Long)
    m_Index = vData
End Property

Public Property Get Owner() As PropertyList
    Set Owner = m_Owner
End Property

Friend Property Set Owner(ByVal vData As PropertyList)
    Set m_Owner = vData
End Property

Public Property Get Object() As Object
    Set Object = m_Object
End Property

Friend Property Set Object(ByVal vData As Object)
    Set m_Object = vData
End Property

Private Sub Class_Initialize()
    Set m_Enums = New EnumsType
    Set m_Edit = New EditWnd
    
    m_Edit.Style = esAutoHScroll
    m_Edit.ThreedBorder = False
    m_Edit.Visible = False
End Sub

Private Sub Class_Terminate()
    Set m_Enums = Nothing
    Set m_Edit = Nothing
    
End Sub

Public Property Get ObjectClass() As String
    ObjectClass = m_ObjectClass
End Property

Public Property Let ObjectClass(ByVal vData As String)
    
    If vData <> "" Then
        m_PropertyType = ptcObject
    End If
    
    m_ObjectClass = vData
End Property

Friend Sub SetRect(vData As RECT)
    CopyMemory m_Rect, vData, Len(m_Rect)

End Sub

Friend Sub GetRect(vData As RECT)
    CopyMemory vData, m_Rect, Len(m_Rect)
End Sub

Public Property Get PropertyType() As PropertyTypeConstants
    PropertyType = m_PropertyType
End Property

Public Property Let PropertyType(ByVal vData As PropertyTypeConstants)
    
    If (vData And (ptcString + ptcEditEllipses)) Then
        m_Value = ""
    ElseIf vData = ptcNumeric Then
        m_Value = 0&
    ElseIf vData = ptcBoolean Then
        m_Value = False
    ElseIf vData = ptcEnum Then
        On Error Resume Next
        m_Value = m_Enums(0)
    End If
    
    m_PropertyType = vData
    
End Property

Public Property Set Value(vData As Object)
    
    If IsObject(vData) Then
        
        If (vData = Empty) Then
            Set m_Value = Nothing
        Else
            Set m_Value = vData
        End If
        
        m_PropertyType = ptcObject
        m_Owner.ListIndex = m_Owner.ListIndex
    End If
    
    Changed = True

End Property
    

Public Property Let Value(vData)
    
    If m_PropertyType = ptcBoolean Then
        
        If (vData = Empty) Then m_Value = False Else _
            m_Value = CBool(vData)
        
    Else
                        
        If (m_PropertyType = ptcNumeric) Then
            If (vData = Empty) Then m_Value = "" _
                Else m_Value = vData
            
            m_Edit.Text = Format(m_Value)
        
        Else
            
            If (vData = Empty) Then m_Value = "" _
                Else m_Value = vData
            
            If (m_PropertyType = ptcString) Or (m_PropertyType = ptcEditEllipses) Then
                m_Edit.Text = m_Value
            End If
            
        End If
        
    End If
    
    Changed = True
    
End Property

Public Property Get Value() As Variant
    
    If IsObject(m_Value) Then
        Set Value = m_Value
    ElseIf m_PropertyType = ptcBoolean Then
        Value = CBool(m_Value)
    Else
        Value = m_Value
    End If
    
End Property

Public Property Get Enums() As EnumsType
    Set Enums = m_Enums
End Property

Public Sub ObjectsOf(ByVal CtrlObj As Object)
    If Not TypeOf CtrlObj Is Control Then Exit Sub
    
    Dim vCtrl As Control
    
    Enums.Clear
    m_PropertyType = ptcObject
    For Each vCtrl In CtrlObj.Controls
    
        If TypeName(vCtrl) = m_ObjectClass Then
            Enums.Add vCtrl.Name
        End If
    
    Next vCtrl

End Sub

Friend Property Get Edit() As EditWnd
    Set Edit = m_Edit
End Property

Private Sub m_Edit_Change()
    
    If m_PropertyType = ptcNumeric Then
        m_Value = Val(m_Edit.Text)
    ElseIf m_PropertyType = ptcString Then
        m_Value = m_Edit.Text
    End If
        
End Sub

Private Sub m_Edit_GotFocus()
    If Not m_Owner Is Nothing Then
        m_Owner.ListIndex = m_Index
    End If
    
    m_Edit.SelStart = 0
    m_Edit.SelEnd = 1
    
End Sub

Private Sub m_Edit_KeyUp(KeyCode As Long, Shift As Long)
   
    If (KeyCode = 13) Then
        If m_PropertyType = ptcNumeric Then
            m_Value = Val(m_Edit.Text)
            m_Edit.Text = Format(m_Value)
        Else
            m_Value = m_Edit.Text
        End If
        
        m_Owner.ListIndex = m_Owner.ListIndex
        If Not m_Owner Is Nothing Then
            m_Owner.SelEvent Me
        End If
        
        SetFocus m_Owner.hWnd
        
    ElseIf KeyCode = 27 Then
        
        m_Owner.ListIndex = m_Owner.ListIndex
        SetFocus m_Owner.hWnd
    
    End If
    
End Sub

Private Sub m_Edit_LostFocus()
    If Not m_Owner Is Nothing Then
        m_Owner.SelEvent Me
        
        m_Edit_Change
        m_Owner.ListIndex = m_Owner.ListIndex
    End If
End Sub
