Attribute VB_Name = "m_PropList"
'' Property Editor Active-X Control
''
'' Version 1.0
''
''
'' m_PropList.bas - Subclassing Module

'' Copyright (C) 2000 The Southern Cross.
'' All Rights Reserved.

'' Unauthorized Commercial Use Strictly Prohibited.
''

Option Explicit
Private Const VarItems As Boolean = False

Public Function ListWndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    On Error Resume Next
    
    Dim vCtl As PropertyList, _
        lProc As Long

    lProc = GetOldProc(hWnd)
    
    If lProc = 0 Then
        ListWndProc = DefWindowProc(hWnd, uMsg, wParam, lParam)
    Else
    
        Set vCtl = GetControl(hWnd)
    
        If Not (vCtl Is Nothing) Then
        
            Select Case uMsg
                        
                Case WM_DRAWITEM
                    
                    ListDrawItem lParam, vCtl
                    ListWndProc = True
                    
                    Exit Function
                                               
                Case WM_MEASUREITEM
                                        
                    ListMeasureItem hWnd, lParam, vCtl
                    ListWndProc = True
                    
                    Exit Function
                            
                Case WM_COMMAND
                     
                    vCtl.FireEvent hWnd, uMsg, wParam, lParam
                    Exit Function
                                     
            End Select
        
        End If
    
        ListWndProc = CallWindowProc(lProc, hWnd, uMsg, wParam, lParam)
    End If
    
End Function

Public Function ListHandleProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    On Error Resume Next
    
    Dim vCtl As PropertyList, _
        lProc As Long

    lProc = GetOldProc(hWnd)
    
    If lProc = 0 Then
        ListHandleProc = DefWindowProc(hWnd, uMsg, wParam, lParam)
    Else
    
        Set vCtl = GetControl(hWnd)
            
        ListHandleProc = CallWindowProc(lProc, hWnd, uMsg, wParam, lParam)
        
        If Not (vCtl Is Nothing) Then
        
            Select Case uMsg
                        
                Case WM_MOUSEMOVE, WM_LBUTTONUP, WM_LBUTTONDOWN, _
                     WM_RBUTTONUP, WM_RBUTTONDOWN, WM_MBUTTONUP, _
                     WM_MBUTTONDOWN, WM_KEYUP, WM_KEYDOWN, WM_PAINT, _
                     WM_LBUTTONDBLCLK, WM_RBUTTONDBLCLK, WM_MBUTTONDBLCLK, _
                     WM_HSCROLL, WM_VSCROLL, WM_MOUSEWHEEL
                     ', WM_COMMAND
                     
                     vCtl.FireEvent hWnd, uMsg, wParam, lParam
                                     
            End Select
        
        End If
    
    End If
    
End Function

Public Function ListMeasureItem(ByVal hWnd As Long, ByVal lParam As Long, hCtl As PropertyList)
    Dim lpMeasure As MEASUREITEMSTRUCT, _
        hDC As Long
        
    Dim lpszText As String, _
        pSize As SIZE
            
    Dim hOldFont As Long
            
    Dim CtlHght As Long, _
        lfFont As LOGFONT, _
        lpRect As RECT
            
    Dim pItem As PropertyType
            
    CopyMemory lpMeasure, ByVal lParam, Len(lpMeasure)

    If (lpMeasure.ItemID <> -1) Then
        Set pItem = hCtl.List(lpMeasure.ItemID)
        lpszText = pItem.Name
    Else
        lpszText = "Wj"
    End If
    
    hDC = GetWindowDC(hWnd)
    SelectObject hDC, hCtl.hFont
    Set pItem.Edit.Font = hCtl.Font
    
    GetTextExtentPoint32 hDC, lpszText, Len(lpszText), pSize
    
    pItem.Edit.Height = pSize.cy

    lpMeasure.itemHeight = pItem.Edit.Height + 2
    If (hCtl.ColumnWidth > pSize.cx) Then
        lpMeasure.itemWidth = hCtl.ColumnWidth
    Else
        lpMeasure.itemWidth = pSize.cx
    End If
        
    CopyMemory ByVal lParam, lpMeasure, Len(lpMeasure)
    ReleaseDC hWnd, hDC
    
End Function

Public Function ListDrawItem(ByVal lParam As Long, hCtl As PropertyList)
    Dim leWidth As Long
    
    Dim lpDraw As DRAWITEMSTRUCT, _
        hDC As Long, _
        hBitmap As Long
        
    Dim hPen As Long
    Dim v As Long
    
    Dim lpszText As String, _
        lpSize As SIZE, _
        Y As Long
        
    Dim hBrush As Long, _
        lpBrush As LOGBRUSH
    
    Dim rcTemp As RECT
    
    Dim pType As PropertyType
    
    CopyMemory lpDraw, ByVal lParam, Len(lpDraw)
    hDC = CreateCompatibleDC(lpDraw.hDC)
    
    With lpDraw.rcItem
        
        rcTemp.Right = (.Right - .Left)
        .Left = 0
        rcTemp.Bottom = .Bottom - .Top
        rcTemp.Top = 0
    
        hBitmap = CreateCompatibleBitmap(lpDraw.hDC, (.Right - .Left) + 1, (.Bottom - .Top) + 1)
        SelectObject hDC, hBitmap
    
    End With
    
    SelectObject hDC, hCtl.hFont
    
    Set pType = hCtl.List(lpDraw.ItemID)
    pType.SetRect lpDraw.rcItem
    
    lpszText = pType.Name
        
    SetBkMode hDC, TRANSPARENT
    
    If (lpDraw.itemState And ODS_SELECTED) Then
        FillRect hDC, rcTemp, COLOR_WINDOW + 1
        
        rcTemp.Right = hCtl.NameMargin
        FillRect hDC, rcTemp, COLOR_HIGHLIGHT + 1
        
        With lpDraw.rcItem
            rcTemp.Right = .Right - .Left
        End With
        
        SetTextColor hDC, GetSysColor(COLOR_HIGHLIGHTTEXT)
        
    Else
    
        FillRect hDC, rcTemp, COLOR_WINDOW + 1
        SetTextColor hDC, GetSysColor(COLOR_WINDOWTEXT)
        
    End If
    
    rcTemp.Right = (rcTemp.Right - 1)
    
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNFACE))
    SelectObject hDC, hPen
    
    Dim lpPoint As POINTAPI
    
    With rcTemp
        MoveToEx hDC, .Left, .Top, lpPoint
        LineTo hDC, .Right, .Top
        
        MoveToEx hDC, .Left, .Bottom, lpPoint
        LineTo hDC, .Right, .Bottom
    
        MoveToEx hDC, .Left + hCtl.NameMargin, .Top, lpPoint
        LineTo hDC, .Left + hCtl.NameMargin, .Bottom
            
    End With
    
    DeleteObject hPen
    
    GetTextExtentPoint32 hDC, lpszText, Len(lpszText), lpSize
      
    Y = ((rcTemp.Bottom - rcTemp.Top)) - lpSize.cy
    Y = Y + (rcTemp.Top - 1)
    
    TextOut hDC, rcTemp.Left + 4, Y, lpszText, Len(lpszText)
        
    SetTextColor hDC, GetSysColor(COLOR_WINDOWTEXT)
        
    Select Case pType.PropertyType
    
        Case ptcEnum:
        
            If pType.Enums.Count > 0 Then
                lpszText = pType.Value
            Else
                SetTextColor hDC, GetSysColor(COLOR_GRAYTEXT)
                lpszText = "(No Enum)"
            End If
            
        Case ptcObject:
            
            If (pType.Value Is Nothing) Then
                lpszText = "(Nothing)"
            ElseIf (pType.Value = Empty) Then
                lpszText = "(Empty)"
            End If
            
        Case ptcBoolean:
            
            If CBool(pType.Value) = True Then
                lpszText = "True"
            Else
                lpszText = "False"
            End If
            
        Case ptcNumeric:
        
            lpszText = Val(pType.Value)
        
        Case ptcString, ptcEllipses, ptcEditEllipses:
        
            lpszText = pType.Value
            
        Case ptcMultiline:
        
            If (pType.Value <> "") Then
                lpszText = "(Text)"
            Else
                lpszText = "(No Text)"
            End If
                        
    End Select
    
    If (hCtl.NameMargin < lpDraw.rcItem.Right) Then
    
        If (pType.PropertyType = ptcString) Or _
            (pType.PropertyType = ptcNumeric) Or _
            (pType.PropertyType = ptcEditEllipses) Then
            
            With pType
            
                If .Edit.Visible = False Then
            
                    .Edit.Left = rcTemp.Left + hCtl.NameMargin + 4
                    .Edit.Top = lpDraw.rcItem.Top + 2
                
                    If .PropertyType = ptcEditEllipses Then
                        .Edit.Width = (lpDraw.rcItem.Right - (lpDraw.rcItem.Left + hCtl.NameMargin + 6)) - hCtl.ButtonWidth
                    Else
                        .Edit.Width = (lpDraw.rcItem.Right - (lpDraw.rcItem.Left + hCtl.NameMargin + 6))
                    End If
                    
                    .Edit.Height = ((lpDraw.rcItem.Bottom - lpDraw.rcItem.Top) - 2)
                    
                    .Edit.Visible = True
                
                Else
                
                    If (.Edit.Top <> (lpDraw.rcItem.Top + 2)) Then
                        .Edit.Top = lpDraw.rcItem.Top + 2
                        .Edit.Height = ((lpDraw.rcItem.Bottom - lpDraw.rcItem.Top) - 2)
                    End If
                                  
                End If
                                
            End With
        Else
            pType.Edit.Visible = False
        End If
        
        If (lpszText <> "") Then
            TextOut hDC, rcTemp.Left + hCtl.NameMargin + 4, Y, lpszText, Len(lpszText)
        End If
        
    End If
    
    If lpDraw.itemState And ODS_SELECTED Then
        hCtl.DrawButton lpDraw.ItemID, False, False, hDC, True
    End If
    
    With lpDraw.rcItem
        If (pType.Edit.Visible = True) Then
            BitBlt hDC, pType.Edit.Left, pType.Edit.Top, pType.Edit.Width, pType.Edit.Height, pType.Edit.hDC, 0, 0, SRCCOPY
        End If
    
        BitBlt lpDraw.hDC, .Left, .Top, ((.Right - .Left) + 1), ((.Bottom - .Top) + 1), hDC, 0, 0, SRCCOPY
        
    End With
                            
    DeleteObject hBitmap
    DeleteDC hDC
    
End Function

