Attribute VB_Name = "m_Util_A"
'' Property Editor Active-X Control
''
'' Version 1.0
''
''
'' m_Util_A.bas - Miscellaneous Utility Functions Module

'' Copyright (C) 2000 The Southern Cross.
'' All Rights Reserved.

'' Unauthorized Commercial Use Strictly Prohibited.
''

Option Explicit


''' Conversion and Initialization Functions and Global Data

Public Type HandleType
    hWnd As Long
    OldWndProc As Long
End Type


Public Type PICTDESCBMP
    SizeofStruct As Long
    picType As Long
    hBitmap As Long
    hPalette As Long
    'Extra As Long
End Type

Public Type PICTDESCICON
    SizeofStruct As Long
    picType As Long
    hIcon As Long
    'Extra As Long
End Type


Global Const MenuIdInitValue = &H1033&
Global g_MenuIdNext As Long

Global g_Handles() As HandleType

'' Collection of all controls on a thread

Public g_Controls As Collection

Public Function AddControl(ByVal hWnd As Long, hCtl As Object)
    On Error Resume Next
    
    g_Controls.Add hCtl, "H" + Hex(hWnd)
End Function

Public Function GetControl(ByVal hWnd As Long) As Object
    On Error Resume Next
    
    Set GetControl = g_Controls("H" + Hex(hWnd))
End Function

Public Sub RemoveControl(ByVal hWnd As Long)
    On Error Resume Next
    
    g_Controls.Remove "H" + Hex(hWnd)
    
    If g_Controls.Count = 0 Then
        Set g_Controls = Nothing
    End If
    
End Sub

Public Sub InitCols()
    On Error Resume Next
    
    If g_Controls Is Nothing Then
        Set g_Controls = New Collection
    End If
    
End Sub

Public Sub AddHandle(ByVal hWnd As Long, Optional ByVal OldProc As Long)
    On Error Resume Next
    Dim i As Long
    
    
    If (OldProc = 0&) Then
        OldProc = GetWindowLong(hWnd, GWL_WNDPROC)
    End If
    
    i = -1
    i = LBound(g_Handles)
    If i = -1 Then
        ReDim g_Handles(1 To 1)
        i = 1
    Else
        i = 1 + UBound(g_Handles)
        ReDim Preserve g_Handles(1 To i)
    End If
    
    g_Handles(i).hWnd = hWnd
    g_Handles(i).OldWndProc = OldProc
End Sub

Public Sub RemoveHandle(ByVal hWnd As Long)
    On Error Resume Next
    
    Dim i As Long, x As Long
    i = -1
    i = LBound(g_Handles)
    If i <= -1 Then Exit Sub
    
    For i = LBound(g_Handles) To UBound(g_Handles)
    
        If g_Handles(i).hWnd = hWnd Then
              
            x = Len(g_Handles(i))
            x = x * (UBound(g_Handles) - i)
            CopyMemory g_Handles(i), g_Handles(i + 1), x
            ReDim Preserve g_Handles(UBound(g_Handles) - 1)
            Exit Sub
        
        End If
            
    Next i
            
End Sub

Public Function GetOldProc(ByVal hWnd As Long) As Long
    On Error Resume Next
    Dim i As Long
    
    i = -1
    i = LBound(g_Handles)
    
    If i < 0 Then Exit Function
    
    For i = LBound(g_Handles) To UBound(g_Handles)
    
        If g_Handles(i).hWnd = hWnd Then
            GetOldProc = g_Handles(i).OldWndProc
            Exit Function
        End If
    
    Next i
    
End Function




Public Function GetOleFont(lfFont As LOGFONT) As StdFont

    Dim riid As GUID
    Dim vData As FONTDESC
    
    Dim vFont As StdFont
    Dim vName As String
    Dim hDC As Long
    
    With riid
    
        .Data1 = &HBEF6E003
        .Data2 = &HA874
        .Data3 = &H101A
        
        .Data4(0) = &H8B
        .Data4(1) = &HBA
        .Data4(2) = &H0
        .Data4(3) = &HAA
        .Data4(4) = &H0
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB
        
    End With
    
    With vData
    
        .cbSize = Len(vData)
        
        hDC = GetDC(0&)
        .cySize = -(MulDiv(lfFont.lfHeight, 72, GetDeviceCaps(hDC, LOGPIXELSY)))
        ReleaseDC 0&, hDC
        
        .sWeight = lfFont.lfWeight
        
        .fStrikethrough = CLng(lfFont.lfStrikeOut)
        .fUnderline = CLng(lfFont.lfUnderline)
        .fItalic = CLng(lfFont.lfItalic)
        vName = CStrToString(lfFont.lfFaceName)
        .szName = StrPtr(vName)
        .sCharset = lfFont.lfCharSet
                
    End With
    
    OleCreateFontIndirect vData, riid, vFont

    ' Sometimes the OS has a difficult time with the size
    
    If Round(vFont.SIZE, 0) <> Round(vData.cySize, 0) Then
        vFont.SIZE = vData.cySize
    End If

    Set GetOleFont = vFont
    
End Function

Public Sub GetLogFont(OleFont As StdFont, lfData As LOGFONT, hDC As Long)
    Dim pDC As Long

    If (hDC = 0&) Then
        pDC = GetDC(0)
        hDC = pDC
    End If

    With lfData
        .lfCharSet = OleFont.Charset
        .lfItalic = OleFont.Italic
        .lfWeight = OleFont.Weight
        
        If OleFont.Bold Then
            .lfWeight = 700
        End If
        .lfQuality = 2
        .lfUnderline = OleFont.Underline
        StringToCStr OleFont.Name, .lfFaceName, True
        .lfStrikeOut = OleFont.Strikethrough
        .lfHeight = -(MulDiv(OleFont.SIZE, GetDeviceCaps(hDC, LOGPIXELSY), 72))
            
    End With

    If pDC <> 0 Then ReleaseDC 0&, pDC

End Sub


